/**
 * DsmlModification.java
 *
 * File generated from the core::DsmlModification uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import net.ihe.gazelle.hpd.gui.DsmlAttrValue;
import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class DsmlModification.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "DsmlModification", propOrder = {
	"value",
	"name",
	"operation"
})
@XmlRootElement(name = "DsmlModification")
public class DsmlModification extends net.ihe.gazelle.gen.common.CommonOperations implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "value", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public List<String> value;
	@XmlAttribute(name = "name", required = true)
	public String name;
	@XmlAttribute(name = "operation", required = true)
	public net.ihe.gazelle.hpd.OperationType operation;
	@XmlTransient
	private List<DsmlAttrValue> valuesForGui;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	public DsmlModification(){

	}

	public DsmlModification(String name, OperationType operation, String inValue) {
		this.name = name;
		this.addValueForGui(inValue);
		this.operation = operation;
	}
	/**
	 * Return value.
	 * @return value
	 */
	public List<String> getValue() {
		if (value == null) {
	        value = new ArrayList<String>();
	    }
	    return value;
	}
	
	/**
	 * Set a value to attribute value.
	 * @param value.
	 */
	public void setValue(List<String> value) {
	    this.value = value;
	}
	
	
	
	/**
	 * Add a value to the value collection.
	 * @param value_elt Element to add.
	 */
	public void addValue(String value_elt) {
	    this.getValue().add(value_elt);
	}
	
	/**
	 * Remove a value to the value collection.
	 * @param value_elt Element to remove
	 */
	public void removeValue(String value_elt) {
	    this.getValue().remove(value_elt);
	}
	
	/**
	 * Return name.
	 * @return name
	 */
	public String getName() {
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(String name) {
	    this.name = name;
	}
	
	
	
	
	/**
	 * Return operation.
	 * @return operation
	 */
	public net.ihe.gazelle.hpd.OperationType getOperation() {
	    return operation;
	}
	
	/**
	 * Set a value to attribute operation.
	 * @param operation.
	 */
	public void setOperation(net.ihe.gazelle.hpd.OperationType operation) {
	    this.operation = operation;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "DsmlModification").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(DsmlModification dsmlModification, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (dsmlModification != null){
   			cvm.validate(dsmlModification, _location, diagnostic);
    	}
    }

	public List<DsmlAttrValue> getValuesForGui() {
		if (valuesForGui == null) {
			valuesForGui = new ArrayList<DsmlAttrValue>();
		}
		return valuesForGui;
	}

	public void addValueForGui(String newValue){
		getValuesForGui().add(new DsmlAttrValue(newValue));
	}

	public void removeValueForGui(DsmlAttrValue attrValue){
		getValuesForGui().remove(attrValue);
	}

	public void setValuesForGui(List<DsmlAttrValue> valuesForGui) {
		this.valuesForGui = valuesForGui;
	}

	public void setValuesForGuiFromValue() {
		for (String val : getValue()) {
			getValuesForGui().add(new DsmlAttrValue(val));
		}
	}

	public void setAttrValueFromGui(){
		for (DsmlAttrValue val: getValuesForGui()){
			addValue(val.getGuiValue());
		}
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) {
			return true;
		}
		if (!(o instanceof DsmlModification)) {
			return false;
		}

		DsmlModification that = (DsmlModification) o;

		if (name != null ? !name.equals(that.name) : that.name != null) {
			return false;
		}
		return operation == that.operation;
	}

	@Override
	public int hashCode() {
		int result = name != null ? name.hashCode() : 0;
		result = 31 * result + (operation != null ? operation.hashCode() : 0);
		return result;
	}
}